#include "parameters.h"

extern int gpu_count;

Parameters *Parameters::instance = NULL;


Parameters& Parameters::get_instance() {
	if (instance == NULL) {
		instance = new Parameters;
	}
	return *instance;
}

Parameters::Parameters() {
	gpu_id = 0;
	size = 1024;
	nbr_repeat = 10;
	verbose = false;
}


void Parameters::setup(int argc, char *argv[], struct option *long_options, int gpu_count) {
	int option_index;
	while (true) {
		option_index = 0;
		int c = getopt_long(argc, argv, "g:r:s:v", long_options, &option_index);
		if (c == -1) break;

		switch(c) {
		case 'g': {
			gpu_id = atoi(optarg);
			if (gpu_id >= gpu_count) {
				throw std::invalid_argument("bad gpu identifier");
			}
		}
		break;

		case 'r': {
			nbr_repeat = atoi(optarg);
			if (nbr_repeat <= 1) {
				throw std::invalid_argument("bad number for repeat");
			}
		}
		break;

		case 's': {
			size = atoi(optarg);
			if ((size < 128) || (size > 1024)) {
				throw std::invalid_argument("bad size");
			}
		}
		break;

		case 'v': {
			verbose = true;
		}
		break;
		}
	}
}
