/*
 * parameters.h
 *
 *  Created on: Sep 12, 2015
 *      Author: richer
 */

#ifndef PARAMETERS_H_
#define PARAMETERS_H_

#include <cstdlib>
#include <cstdio>
#include <iostream>
#include <stdexcept>
using namespace std;
#include <getopt.h>

class Parameters {
public:
	// identifier of GPU that will run CUDA code
	int gpu_id;
	// size of vector
	int size;
	// number of times the code is executed
	int nbr_repeat;
	// print more information
	bool verbose;

	/**
	 * return reference to unique instance of class
	 */
	static Parameters& get_instance();

	void setup(int argc, char *argv[], struct option *long_options, int gpu_count);

	/**
	 * print contents of class
	 */
	friend ostream& operator<<(ostream& out, Parameters& p) {
		out << "gpu_id=" << p.gpu_id << endl;
		out << "size=" << p.size << endl;
		out << "nbr_repeat=" << p.nbr_repeat << endl;
		out << "verbose=" << p.verbose << endl;
		return out;
	}

private:
	static Parameters *instance;

	// default constructor
	Parameters();
};



#endif /* PARAMETERS_H_ */
